# $Id: modsdatefield.py 3919 2010-08-31 06:51:38Z place $
# $URL: https://svn.non-gnu.uvt.nl/uvt-dev/tags/sources/meresco/bzv-9.9.10/src/delfttilburg/modsdatefield.py $
## begin license ##
#
#    "Delft-Tilburg" (delfttilburg) is a package containing shared code
#    between the Delft "Discover" and Tilburg "Beter Zoeken & Vinden" projects.
#    Both projects are based on Meresco Software (http://meresco.com)
#    Copyright (C) 2008-2009 Technische Universiteit Delft http://www.tudelft.nl
#    Copyright (C) 2008-2009 Universiteit van Tilburg http://www.uvt.nl
#    Copyright (C) 2008-2009 Seek You Too (CQ2) http://www.cq2.nl
#
#    This file is part of "Delft-Tilburg".
#
#    "Delft-Tilburg" is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    "Delft-Tilburg" is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with "Delft-Tilburg"; if not, write to the Free Software
#    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
#
## end license ##
from meresco.core import Observable

class ModsDateField(Observable):

    def __init__(self):
        Observable.__init__(self)
        self._namespaceMap = {'mods':'http://www.loc.gov/mods/v3'}

    def addXml(self, lxmlNode):
        dates = lxmlNode.xpath('//mods:mods/mods:originInfo/mods:dateIssued/text()', namespaces=self._namespaceMap)
        if len(dates) == 0:
            dates = lxmlNode.xpath('//mods:mods/mods:originInfo/mods:dateOther/text()', namespaces=self._namespaceMap)
            if len(dates) > 0:
                for date in dates:
                    yield self.all.addField(name='mods.originInfo.dateIssued', value=date)
                return

        if len(dates) == 0:
            yield self.all.addField(name='mods.originInfo.dateIssued', value='unknown')
